-------------------------------------------------------------------------------------------------
-- buEdgeSketch.mcr Ver.1.0
-- ؘaG kasiwagi@ummb.jp
-------------------------------------------------------------------------------------------------
-- |S̕ӂ̒蒼ړIƂc[łB
-- fBeB[Abvׂ̈ɖʂוĂƂAꉞo܂B
-- 悭NbNł͂ȂhbOőł̂
-- ^ubgɂ₳dlɂȂĂ܂B
-- _A^b`łij
-------------------------------------------------------------------------------------------------
--  g
-- 
-- ӂ𐶐				ʓŃhbO
-- ӂ폜				ӏhbO (ctrl{hbOŃN[폜j
-- Xs				ӏshift{hbOiOp̎̂݁j
-- _}				ӏalt{hbO({ctrlŒ_̘Aj
-- ӂ̏W				ӏalt{shift{hbO
-------------------------------------------------------------------------------------------------
--  CXg[
-- 
-- <max>\ui\MacroScriptsɃRs[āAV[gJbgȂȂȂɓo^
-------------------------------------------------------------------------------------------------
--  dlA
-- 
-- O̕ӂȂǂɂ͒_̑}͏o܂Bӂɐڂ闼ʂ`ŃhbOĂB
-- undo͈܂Ƃ߂ł߂܂B̂Ƃʂundo@͕słcc
-------------------------------------------------------------------------------------------------
--  
-- 
-- 1.0 ЂƂ܂
-- 0.8 cuťvZ𒼂
-- 0.7 ӂcollapseǉ
-- 0.6 undoItɂēĂ݂R(߁)@GbWɂ񒸓_悤ɂB
-- 0.5 }EXc[ō蒼BӕǉBză_CAO߂B
-- 0.2 XsBׂ̈Ƀ_CAOɂĂ݂B
-- 0.1 g
-------------------------------------------------------------------------------------------------

macroScript buEdgeSketch
	category:"Bu"
	buttontext:"buEdgeSketch"
	toolTip:"buEdgeSketch" 
(
	local targetObj
	local loopF
	local cutVertList = #{}

	fn getPolyFace i =
	(
		local v = (meshop.getVertsUsingFace targetObj.mesh i) as array
		local f1 = polyOp.getFacesUsingVert targetObj v[1]
		local f2 = polyOp.getFacesUsingVert targetObj v[2]
		local f3 = polyOp.getFacesUsingVert targetObj v[3]
		return ((f1*f2*f3) as array)[1]
	)

	fn createEdge p1 vp1 vp2 = -- p1:index vp1,vp2:n_ƏI_
	(
		local vi = (polyOp.getVertsUsingFace targetObj p1) as array
		local l1Ar = #() -- n_
		local l2Ar = #() -- I_
		for i in vi do
		(
			local tmp = (polyOp.getVert targetObj i) - vp1
			append l1Ar (length tmp)
			append l2Ar (dot (normalize tmp) (normalize (vp2 - vp1)))
		)
		local v1i = findItem l1Ar (amin l1Ar) -- ԋ߂_
		local v2i = findItem l2Ar (amax l2Ar) -- PɈԋ߂
		targetObj.createEdge vi[v1i] vi[v2i] -- d͍lȂĂǂ悤
	)

	fn collapseEdge p1 p2 =
	(
		local e = (polyOp.getEdgesUsingFace targetObj p1) * (polyOp.getEdgesUsingFace targetObj p2)
		if e.numberSet >= 1 do -- ڂĂ鎞
		(
			polyOp.setEdgeSelection targetObj e
			targetObj.collapse #edge
		)
	)

	fn deleteEdge p1 p2 =
	(
		local e = (polyOp.getEdgesUsingFace targetObj p1) * (polyOp.getEdgesUsingFace targetObj p2)
		if e.numberSet >= 1 do -- ڂĂ鎞
		(
			polyOp.setEdgeSelection targetObj e
			targetObj.remove selLevel:#edge
		)
	)

	fn spinEdge p1 p2 =
	(
		local e = (polyOp.getEdgesUsingFace targetObj p1) * (polyOp.getEdgesUsingFace targetObj p2)
		local v1 = polyOp.getVertsUsingFace targetObj p1
		local v2 = polyOp.getVertsUsingFace targetObj p2
		if v1.numberSet == 3 and v2.numberSet == 3 and e.numberSet == 1 do -- Opm̂
		(
			local v12 = polyOp.getVertsUsingEdge targetObj e
			v1 = ((v1 - v12) as array)[1]
			v2 = ((v2 - v12) as array)[1]
			polyOp.setEdgeSelection targetObj e
			targetObj.remove selLevel:#edge -- ctrlĂƕsvȒ_
			targetObj.createEdge v1 v2
		)
	)

	fn cutEdge p1 p2 vp1 vp2 =
	(
		local e = (polyOp.getEdgesUsingFace targetObj p1) * (polyOp.getEdgesUsingFace targetObj p2)
		local forF = true -- exit͎gƒx񂾂(L3`)
		for i in e while forF do 
		(
			local v12ar = (polyOp.getVertsUsingEdge targetObj i) as array
			local v1 = polyOp.getVert targetObj v12ar[1]
			local v2 = polyOp.getVert targetObj v12ar[2]
			local v12 = normalize(v2 - v1)
			
			local n12 = (Inverse(getViewTM())).row3 -- 
			n12 = normalize(cross v12 (cross v12 n12))
			vp1 += n12 * (dot (v1 - vp1) n12)
			vp2 += n12 * (dot (v2 - vp1) n12)
			
			local et1 = normalize(cross (vp1 - v1) (v2 - v1))
			local et2 = normalize(cross (vp2 - v1) (v2 - v1))
			local et3 = normalize(cross (v1 - vp1) (vp2 - vp1))
			local et4 = normalize(cross (v2 - vp1) (vp2 - vp1))
			if  dot et1 et2 < 0.001 and dot et3 et4 < 0.001  do
			(	-- OɌ_߂
				local np1 = normalize (cross (vp2 - vp1) n12) -- Xg[Nւ̐ȃxNg
				local cpLen = (dot (vp1 - v1) np1) / (dot v12 np1) -- v1_܂ł̒
				local targetV = targetObj.insertVertexInEdge i 0.5 -- ǂ_͕sH
				polyop.setVert targetObj targetV (v1 + v12*cpLen)

				if keyboard.controlPressed do -- ܂FȂ񂩋H
					if cutVertList.isEmpty then
						cutVertList = #{targetV}
					else (
						cutVertList[targetV] = true
						polyOp.setVertSelection targetObj cutVertList
						targetObj.ConnectVertices()
						cutVertList = #{targetV}
						polyOp.setVertSelection targetObj cutVertList
					)

				forF = false
			)
		)
	)

	fn checkStroke mR1 mR2 =
	(
		local mf1,mf2
		with redraw off
		(
			local sm = snapshot targetObj			-- bVɂg˂̂
			mf1 = intersectRayEx sm mR1
			mf2 = intersectRayEx sm mR2
			delete sm
		)

		if (mf1 != undefined) and (mf2 != undefined) do
		(
			local pf1 = getPolyFace mf1[2]
			local pf2 = getPolyFace mf2[2]
			if pf1 == pf2 then createEdge pf1 mf1[1].pos mf2[1].pos
			else if keyboard.shiftPressed and keyboard.altPressed then collapseEdge pf1 pf2
			else if keyboard.shiftPressed then spinEdge pf1 pf2
			else if keyboard.altPressed then cutEdge pf1 pf2 mf1[1].pos mf2[1].pos
			else deleteEdge pf1 pf2
		)
	)

	tool mtEdgeSketch
	(
		local mR1,mR2
		on mousePoint clickno do
		(
			if clickno == 1 then
				mR1 = mapScreenToWorldRay viewPoint
			else (
				mR2 = mapScreenToWorldRay viewPoint
				checkStroke mR1 mR2
				#stop
			)
		)
		on mouseAbort clickno do loopF = false
	)

	On IsEnabled Return Filters.Is_EPoly()
	On IsVisible Return Filters.Is_EPoly()
	On Execute Do
	(
		enableUndo off -- Ƃ肠(߁`)
		loopF = true
		try
		(
			if (targetObj = selection[1]) != undefined and (classof targetObj) == Editable_Poly do
				while loopF do startTool mtEdgeSketch
		) catch (stopTool mtEdgeSketch)
		cutVertList = #{}
		enableUndo on
	)
)